/* SP.C - ShortPath 
   Truncates strings longer than given maximum 
   reads from stdin, writes to stdout 
   (C) Harald Milz and iX 11/92
*/

#include <stdio.h>
#include <string.h>

#define MAXCHARS (256)              /* maximum string length */

main (argc, argv)
int argc; 
char **argv;
{ char path[MAXCHARS];
  int len; 
  int maxpathlen = 30;              /* default */

  if (argc == 2)                    /* if exactly one cmdline arg */
    if (sscanf (argv[1], "%d", &maxpathlen) == EOF) /* if conversion error */
      maxpathlen = 30;              /* then default value */
  fgets (path, MAXCHARS-1, stdin);  /* read from stdin */
  len = strlen (path);              /* determine length */
  if (len > maxpathlen)             /* if string too long */
  { fputs ("... ", stdout);         /* output "... " */
    fputs (&path [len-maxpathlen-1], stdout); /* and remainder of string */
  } /* if */
  else fputs (path, stdout);        /* else output original string */
} /* main() */

